/*
=============================================================================
Smartport Virtual Hard Drive, version 0.99.0 (beta)


If you would like to be involved in this project, or simply get my 
documentation for your own smartport project, feel free to contact me at
pcedric@hotmail.com

Copyright 2010 Cédric PELTIER, pcedric@hotmail.com

This file is part of the Smartport VHD project

Smartport VHD is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation version 3

Smartport VHD is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Smartport VHD. If not, see <http://www.gnu.org/licenses/>.
=============================================================================
*/

/*
             LUFA Library
     Copyright (C) Dean Camera, 2010.
              
  dean [at] fourwalledcubicle [dot] com
      www.fourwalledcubicle.com
*/

/*
  Copyright 2010  Dean Camera (dean [at] fourwalledcubicle [dot] com)

  Permission to use, copy, modify, distribute, and sell this 
  software and its documentation for any purpose is hereby granted
  without fee, provided that the above copyright notice appear in 
  all copies and that both that the copyright notice and this
  permission notice and warranty disclaimer appear in supporting 
  documentation, and that the name of the author not be used in 
  advertising or publicity pertaining to distribution of the 
  software without specific, written prior permission.

  The author disclaim all warranties with regard to this
  software, including all implied warranties of merchantability
  and fitness.  In no event shall the author be liable for any
  special, indirect or consequential damages or any damages
  whatsoever resulting from loss of use, data or profits, whether
  in an action of contract, negligence or other tortious action,
  arising out of or in connection with the use or performance of
  this software.
*/
 
#ifndef _MASS_STORE_HOST_H_
#define _MASS_STORE_HOST_H_

		#include <avr/io.h>
		#include <avr/wdt.h>
		#include <avr/pgmspace.h>
		#include <avr/power.h>
		#include <stdio.h>
		#include <ctype.h>
		#include <string.h>
		#include <LUFA/Version.h>
		#include <LUFA/Drivers/Misc/TerminalCodes.h>
		#include <LUFA/Drivers/USB/USB.h>
		#include <LUFA/Drivers/USB/Class/MassStorage.h>
		#include "MassStoreCommands.h"
        #include "spvhd.h"
#ifdef CFG_DEBUG_SERIAL
        #include <LUFA/Drivers/Peripheral/Serial.h>
        #include <LUFA/Drivers/Peripheral/SerialStream.h>
#endif

    /* Function Prototypes: */
        void usb_init(uint8_t step);
        void usb_main(void);
        int8_t usb_read_block(uint32_t address,uint8_t* p_dst);
        int8_t usb_write_block(uint32_t address,uint8_t* p_src);
    
        void EVENT_USB_Host_HostError(const uint8_t ErrorCode);
        void EVENT_USB_Host_DeviceAttached(void);
        void EVENT_USB_Host_DeviceUnattached(void);
        void EVENT_USB_Host_DeviceEnumerationFailed(const uint8_t ErrorCode, const uint8_t SubErrorCode);
        void EVENT_USB_Host_DeviceEnumerationComplete(void);

        void usb_DiskReadError(char* CommandString, uint8_t ErrorCode);

#endif
