/*
=============================================================================
Smartport Virtual Hard Drive, version 1.00.0

Copyright 2010-2012 Cédric PELTIER, pcedric@hotmail.com

This file is part of the Smartport VHD project

Smartport VHD is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation version 3

Smartport VHD is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Smartport VHD. If not, see <http://www.gnu.org/licenses/>.
=============================================================================
*/

#ifndef DS1307
#define DS1307

#include <string.h>
#include "spvhd.h"
#include "i2c.h"

#define DS1307_ID    0xD0        // I2C DS1307 Device Identifier
#define DS1307_ADDR  0x00        // I2C DS1307 Device Address

#define DS1307_24H 0
#define DS1307_12H 1

bool ds1307_read(uint8_t* lp_ptr);
bool ds1307_write(uint8_t* lp_ptr);
uint8_t bin2bcd(uint8_t l_bin);
uint8_t bcd2bin(uint8_t l_bcd);

#endif
