/*
=============================================================================
Smartport Virtual Hard Drive, version 0.99.0 (beta)
main source file

If you would like to be involved in this project, or simply get my 
documentation for your own smartport project, feel free to contact me at
pcedric@hotmail.com

Copyright 2010 Cédric PELTIER, pcedric@hotmail.com

This file is part of the Smartport VHD project

Smartport VHD is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation version 3

Smartport VHD is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Smartport VHD. If not, see <http://www.gnu.org/licenses/>.
=============================================================================
*/

#ifndef _EXTSRAM_H_
#define _EXTSRAM_H_
    
    #if (defined(__AVR_AT90USB1287__) || defined(__AVR_AT90USB1286__))
        #define EXT_SRAM_START          0x2100
    #elif (defined(__AVR_AT90USB647__) || defined(__AVR_AT90USB646__) || defined(__AVR_ATmega32U6__))
        #define EXT_SRAM_START          0x1100
    #endif
    #if (SRAM_BANKS == 2)
      // using two banks of 60KB each
      #define EXT_SRAM_END                    0xFFFF
      #define EXT_SRAM_SIZE                   (EXT_SRAM_END - EXT_SRAM_START)
      #define SELECT_EXTSRAM_BANK0            PORTE &= ~(1 << PE7);
      #define SELECT_EXTSRAM_BANK1            PORTE |= (1 << PE7);
      #define SELECT_EXTSRAM_BANK2            SELECT_EXTSRAM_BANK0
      #define SELECT_EXTSRAM_BANK3            SELECT_EXTSRAM_BANK1
    #endif
    #if (SRAM_BANKS == 4)
      // using four banks of 32KB each
      #define EXT_SRAM_SIZE                   32767
      #define EXT_SRAM_END                    (EXT_SRAM_START + EXT_SRAM_SIZE)
      #define SELECT_EXTSRAM_BANK0            PORTE &= ~(1 << PE7);PORTC &= ~(1 << PC7);
      #define SELECT_EXTSRAM_BANK1            PORTE &= ~(1 << PE7);PORTC |= (1 << PC7);
      #define SELECT_EXTSRAM_BANK2            PORTE |= (1 << PE7);PORTC &= ~(1 << PC7);
      #define SELECT_EXTSRAM_BANK3            PORTE |= (1 << PE7);PORTC |= (1 << PC7);
    #endif

    // =============================================================================
    // Function Prototypes

    void xr_init(void);
    uint8_t xr_init_test(uint8_t* array, const uint16_t startAddress, const uint16_t endAddress);
    void xr_main(void);

#endif
