/*
=============================================================================
Smartport Virtual Hard Drive, version 1.00.0

Copyright 2010-2012 Cédric PELTIER, pcedric@hotmail.com

This file is part of the Smartport VHD project

Smartport VHD is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation version 3

Smartport VHD is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Smartport VHD. If not, see <http://www.gnu.org/licenses/>.
=============================================================================
*/

#ifndef I2C
#define I2C

#include <util/delay.h>
#include <avr/pgmspace.h> 
#include <util/twi.h>
#include "spvhd.h"

#define I2C_MAX_TRIES 100
#define I2C_MAX_SYNC 10000

uint8_t i2c_sync(void);
uint8_t i2c_start(void);
uint8_t i2c_nack(void);
uint8_t i2c_ack(void);
void i2c_stop(void);
bool i2c_init(uint8_t l_id, uint8_t l_addr, uint8_t l_rw);
bool i2c_write(uint8_t data);
bool i2c_read(uint8_t *data,bool l_ack);

#endif
